//+------------------------------------------------------------------+
//|                                                        ma trends |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Gold
#property indicator_color3  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//    default parameters for LWMA type (MAMethod 3) : 50,50,150
//    default parameters for SSMA type (MAMethod 2) : 25,25,125
//
//

extern int FastMA   =  50;
extern int MediumMA =  50;
extern int SlowMA   = 150;
extern int MAMethod = MODE_LWMA;

//
//
//
//
//

double bufferUp[];
double bufferDn[];
double bufferNe[];
double bufferMf[];
double bufferMm[];
double bufferMs[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,bufferUp); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,bufferNe); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,bufferDn); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,bufferMf);
      SetIndexBuffer(4,bufferMm);
      SetIndexBuffer(5,bufferMs);
      SetIndexBuffer(6,trend);
      
      //
      //
      //
      //
      //
      
   MAMethod = MathMax(MathMin(MAMethod,3),0);
      string method = "";
      switch(MAMethod)         
      {
         case 0 : method = "SMA";  break;
         case 1 : method = "EMA";  break;
         case 2 : method = "SMMA"; break;
         case 3 : method = "LWMA";
      }
   
   IndicatorShortName("Ma trends "+method+" : ("+FastMA+","+MediumMA+","+SlowMA+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      bufferMf[i] = iMA(NULL,0,FastMA  ,0,MAMethod, PRICE_CLOSE, i);
      bufferMm[i] = iMA(NULL,0,MediumMA,0,MAMethod, PRICE_CLOSE, i);
      bufferMs[i] = iMA(NULL,0,SlowMA  ,0,MAMethod, PRICE_CLOSE, i);
      if (i==(Bars-1))
      {
         trend[i] = 0;
         continue;
      }         

      //
      //
      //
      //
      //

      trend[i] = trend[i+1];
      while(true)
      {
         if (bufferMf[i+1]<bufferMs[i+1] && bufferMf[i]>bufferMs[i]) { trend[i] =  1; break; }
         if (bufferMf[i+1]>bufferMs[i+1] && bufferMf[i]<bufferMs[i]) { trend[i] = -1; break; }

         if (trend[i] ==  1) if (bufferMf[i+1]>bufferMm[i+1] && bufferMf[i]<bufferMm[i]) { trend[i] = 0; break; }
         if (trend[i] == -1) if (bufferMf[i+1]<bufferMm[i+1] && bufferMf[i]>bufferMm[i]) { trend[i] = 0; break; }
         if (trend[i] == -1)
         {
            if (bufferMf[i+1]>bufferMm[i+1] && bufferMf[i]<bufferMm[i]) { trend[i] = -1; break; }
            if (bufferMf[i+1]<bufferMm[i+1] && bufferMf[i]>bufferMm[i]) { trend[i] =  1; break; }
         }
         break;               
      }  
      
      //
      //
      //
      //
      //
             
      bufferUp[i] = EMPTY_VALUE;
      bufferNe[i] = EMPTY_VALUE;
      bufferDn[i] = EMPTY_VALUE;
         if (trend[i] ==  1) bufferUp[i] = 1;
         if (trend[i] ==  0) bufferNe[i] = 1;
         if (trend[i] == -1) bufferDn[i] = 1;
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}